part of tecfy_basic_package;

class MultiSelectDialog extends StatefulWidget {
  final List<dynamic> items;
  final List<dynamic> selectedItems;
  final dynamic onChange;
  final String? labelPropertyName;
  MultiSelectDialog(this.items, this.selectedItems, this.onChange,
      {this.labelPropertyName});
  @override
  _MultiSelectDialogState createState() => _MultiSelectDialogState();
}

class _MultiSelectDialogState extends State<MultiSelectDialog> {
  @override
  Widget build(BuildContext context) {
    return Column(children: <Widget>[
      Expanded(child: Container()),
      Card(
          shape: RoundedRectangleBorder(
            borderRadius: BorderRadius.circular(30.0),
          ),
          color: Colors.white,
          child: Container(
              height: 500.0,
              width: 300.0,
              child: ListView(
                  padding: EdgeInsets.only(left: 30.0, right: 30.0, top: 20),
                  children: widget.items
                      .map((item) => MainCheckBox(
                              widget.selectedItems.contains(item),
                              item[widget.labelPropertyName ?? 'display'], (v) {
                            if (v) {
                              widget.selectedItems.add(item);
                            } else {
                              widget.selectedItems.remove(item);
                            }
                            widget.onChange(widget.selectedItems);
                            setState(() {});
                          }))
                      .toList()))),
      SizedBox(height: 15.0),
      ButtonTheme(
          minWidth: 300.0,
          height: 60.0,
          child: MaterialButton(
            shape: RoundedRectangleBorder(
                borderRadius: new BorderRadius.circular(50.0)),
            color: Colors.white,
            onPressed: () => Navigator.of(context).pop(widget.selectedItems),
            child: Text('DONE',
                style: TextStyle(
                    color: ThemeService.mainColor,
                    fontSize: 20,
                    fontWeight: FontWeight.bold)),
          )),
      Expanded(
        child: Container(),
      ),
    ]);
  }
}
